#!/usr/env/python

import os

homedir = os.getenv ("HOME")

def transition_internal ():

    os.system ("cp " + homedir + "/.compiz/ " + homedir + "/.compiz-1-testing")
    print "[LOG]: Moved internal files to .compiz-1-testing"

def move_ini_setting (lines, setting, oldplugin, newplugin):

    old_plugin_start = 0
    old_plugin_end = 0    

    for line in lines:

	if line is "[" + oldplugin + "]":
	    old_plugin_start = lines.index (line)

	# this is the next plugin's line
	if old_plugin_start is not 0:
	    if line.startswith ("["):
		old_plugin_end = lines.index (line) - 1
		break

    slinepos = -1
    pos = 0

    for line in lines:
	if "s0_" + setting in line:
	    slinepos = pos
	    break
	pos = pos + 1

    if slinepos is -1:
	print "[LOG]: setting " + setting + " is not set - using default"
	return lines

    # we found the setting, now find the new plugin

    new_plugin_start = 0
    new_plugin_end = 0

    for line in lines:

	if line is "[" + newplugin + "]":
	    new_plugin_start = lines.index (line)

	# this is the next plugin's line
	if new_plugin_start is not 0:
	    if line.startswith ("["):
		new_plugin_end = lines.index (line) - 1
		break

    lineval = lines.pop (slinepos)

    lines.insert (old_plugin_end, lineval) 

    print "[LOG]: Intserted setting " + setting + "from plugin " + oldplugin + " into " + newplugin

    return lines  

def transition_ini ():

    os.system ("cp " + homedir + "/.config/compiz/ " + homedir + "/.config/compiz-1-testing")
    print "[LOG]: Moved config to .config/compiz-1-testing"
    dirname = homedir + "/.config/compiz-1-testing/compizconfig"

    try:
	files = os.listdir (dirname)
    except OSError:
	print "[ERROR]: ~/.config/compiz-1 not found! Please file a bug on bugs.launchpad.net/~unity"
	return

    for fname in files:

	if "config" in fname:
	    continue

	file = open (dirname + "/" + fname, "r")
	contents = file.read ()

	# the name of the decoration plugin changed

	contents = contents.replace ("decoration", "decor")

	# no more "allscreens", change all instances of "as_" to "s0_"

	contents = contents.replace ("as_", "s0_")

	# split it all into lines

	lines = contents.splitlines(True)

	# now go through each line, move settings around, etc:

	for line in lines:

	    # add opengl and composite and compiztoolbox to active_plugins
	    if line.startswith ("s0_active_plugins"):
		print "[LOG]: Adding new plugins"
		offset = len ("as_active_plugins = core;ccp;")
		line = line[0:offset] + "detection;bailer;composite;opengl;compiztoolbox;" + line[offset:]
		print "[LOG]: New plugins list is " + line[len("as_active_plugins = "):len (line) - 2]

	# some settings from the core plugin now go in the opengl and composite plugins
	lines = move_ini_setting (lines, "slow_animations_key", "core", "composite")
	lines = move_ini_setting (lines, "detect_refresh_rate", "core", "composite")
	lines = move_ini_setting (lines, "refresh_rate", "core", "composite")
	lines = move_ini_setting (lines, "unredirect_fullscreen_windows", "core", "composite")
	lines = move_ini_setting (lines, "force_independent_output_painting", "core", "composite")
	lines = move_ini_setting (lines, "texture_filter", "core", "opengl")
	lines = move_ini_setting (lines, "lighting", "core", "opengl")
	lines = move_ini_setting (lines, "sync_to_vblank", "core", "opengl")
	lines = move_ini_setting (lines, "texture_compression", "core", "composite")

	print lines

print "Running compiz transition script - transitioning from Compiz 0.8 to Compiz 0.9"
print "[LOG]: Moving plugins and data to compiz-1"
transition_internal ()
print "[LOG]: Moving and rewriting INI settings from compiz and data to compiz-1"
transition_ini ()
    
